ClassNameIdResolver
Date: 2016-12-04

com.fasterxml.jackson.databind.jsontype.impl

## Class ClassNameIdResolver

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase
  - - com.fasterxml.jackson.databind.jsontype.impl.ClassNameIdResolver

- All Implemented Interfaces:
    TypeIdResolver
  Direct Known Subclasses:
    MinimalClassNameIdResolver

      public class ClassNameIdResolver
      extends TypeIdResolverBase

  `TypeIdResolver` implementation that converts between fully-qualified Java class names and (JSON) Strings.

- - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase

      `_baseType, _typeFactory`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ClassNameIdResolver(JavaType baseType, TypeFactory typeFactory)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.String` | `_idFrom(java.lang.Object value, java.lang.Class<?> cls, TypeFactory typeFactory)`
    `protected JavaType` | `_typeFromId(java.lang.String id, DatabindContext ctxt)`
    `java.lang.String` | `getDescForKnownTypeIds()` Helper method used to get a simple description of all known type ids, for use in error messages.
    `com.fasterxml.jackson.annotation.JsonTypeInfo.Id` | `getMechanism()` Accessor for mechanism that this resolver uses for determining type id from type.
    `java.lang.String` | `idFromValue(java.lang.Object value)` Method called to serialize type of the type of given value as a String to include in serialized JSON content.
    `java.lang.String` | `idFromValueAndType(java.lang.Object value, java.lang.Class<?> type)` Alternative method used for determining type from combination of value and type, using suggested type (that serializer provides) and possibly value of that type.
    `void` | `registerSubtype(java.lang.Class<?> type, java.lang.String name)`
    `JavaType` | `typeFromId(DatabindContext context, java.lang.String id)` Method called to resolve type from given type identifier.

    - ### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeIdResolverBase

      `idFromBaseType, init`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ClassNameIdResolver

          public ClassNameIdResolver(JavaType baseType,
                             TypeFactory typeFactory)

  - ### Method Detail

    - #### getMechanism

          public com.fasterxml.jackson.annotation.JsonTypeInfo.Id getMechanism()

      Description copied from interface: `TypeIdResolver`
      Accessor for mechanism that this resolver uses for determining type id from type. Mostly informational; not required to be called or used.

    - #### registerSubtype

          public void registerSubtype(java.lang.Class<?> type,
                             java.lang.String name)

    - #### idFromValue

          public java.lang.String idFromValue(java.lang.Object value)

      Description copied from interface: `TypeIdResolver`
      Method called to serialize type of the type of given value as a String to include in serialized JSON content.

    - #### idFromValueAndType

          public java.lang.String idFromValueAndType(java.lang.Object value,
                                            java.lang.Class<?> type)

      Description copied from interface: `TypeIdResolver`
      Alternative method used for determining type from combination of value and type, using suggested type (that serializer provides) and possibly value of that type. Most common implementation will use suggested type as is.

    - #### typeFromId

          public JavaType typeFromId(DatabindContext context,
                            java.lang.String id)
                              throws java.io.IOException

      Description copied from interface: `TypeIdResolver`
      Method called to resolve type from given type identifier.
      Specified by:
        `typeFromId` in interface `TypeIdResolver`
      Overrides:
        `typeFromId` in class `TypeIdResolverBase`
      Throws:
        `java.io.IOException`

    - #### _typeFromId

          protected JavaType _typeFromId(java.lang.String id,
                             DatabindContext ctxt)
                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _idFrom

          protected final java.lang.String _idFrom(java.lang.Object value,
                                 java.lang.Class<?> cls,
                                 TypeFactory typeFactory)

    - #### getDescForKnownTypeIds

          public java.lang.String getDescForKnownTypeIds()

      Description copied from class: `TypeIdResolverBase`
      Helper method used to get a simple description of all known type ids, for use in error messages.
      Specified by:
        `getDescForKnownTypeIds` in interface `TypeIdResolver`
      Overrides:
        `getDescForKnownTypeIds` in class `TypeIdResolverBase`